require("menu")

gui = require("Quickie")

function love.load()
	-- global variables
    window_main_w = 1024
    window_main_h = 768

    
    -- group defaults
    gui.group.default.spacing = 5

    -- preload fonts
    fonts = {
        [40] = love.graphics.newFont(40),
        [100] = love.graphics.newFont(100),
    }
    
    assert(love.window.setMode(window_main_w,
		window_main_h,
		{borderless = true}),
		"Failed to set window mode.")
    
    love.graphics.setBackgroundColor(40,80,100)


	--[[ Allowed game state transitions:
	main	->	game
	main	->	intro
	main	->	quit
	intro	->	main
	game	->	retry
	retry	->	game
	retry	->	credits
	credits	->	quit
	]]--
	state = {
		main = true,
		game = false,
		intro = false,
		retry = false,
		credits = false,
		quit = false,
	}
	
end

function love.update(dt)
	if state.main then
		main_menu()
	elseif state.game then
		game()
	elseif state.intro then
		introduction()
	elseif state.retry then
		retry()
	elseif state.credits then
		credits()
	elseif state.quit then
		quit()
	end
end

function love.draw()
    gui.core.draw()
end


