button_main_menu_w = 300
button_main_menu_h = 100
title_top_spacing = 100

-- necessary to make menu keyboard input work
function love.keypressed(key, code)
    gui.keyboard.pressed(key)
end

    
function main_menu()
	local title = "GIGADOOMER"
    love.graphics.setFont(fonts[100])
    local spacing = (window_main_w - fonts[100]:getWidth(title))/2
	gui.Label{text = title,
		pos = {spacing, title_top_spacing},
	}

	love.graphics.setFont(fonts[40])
    
    gui.group.push{grow = "down"}
		if gui.Button{text = "Start",
			pos = {window_main_w/2-button_main_menu_w/2, window_main_h/2-button_main_menu_h/2},
			size = {button_main_menu_w, button_main_menu_h}}
		then
				state.main = false
				state.game = true
				
		elseif gui.Button{text = "Introduction",
			pos = {window_main_w/2-button_main_menu_w/2, gui.group.default.spacing},
			size = {button_main_menu_w, button_main_menu_h}}
		then
				state.main = false
				state.intro = true
				
		elseif gui.Button{text = "Exit",
			pos = {window_main_w/2-button_main_menu_w/2, gui.group.default.spacing},
			size = {button_main_menu_w, button_main_menu_h}}
		then
				state.main = false
				state.quit = true	
		else -- do nothing
		end		
		
	gui.group.pop{}
end

function introduction()
	gui.group.push{grow = "down"}
		local title = "INTRODUCTION"
		love.graphics.setFont(fonts[100])
		local spacing = (window_main_w - fonts[100]:getWidth(title))/2
		gui.Label{text = title,
			pos = {spacing, title_top_spacing},
		}
	

		local btn_back_text = "BACK"
		love.graphics.setFont(fonts[40])
		local spacing = (window_main_w - button_main_menu_w)/2
		if gui.Button{text = btn_back_text,
				pos = {spacing, title_top_spacing * 3},
				size = {button_main_menu_w, button_main_menu_h}}
		then
				state.intro = false
				state.main = true
		end
    gui.group.pop{}
end

function game()
    love.graphics.setBackgroundColor(0,0,0)
    
    local title = "GAME - press ESC for retry screen"
		love.graphics.setFont(fonts[40])
		local spacing = (window_main_w - fonts[40]:getWidth(title))/2
		gui.Label{text = title,
			pos = {spacing, title_top_spacing},
		}
		
	if love.keyboard.isDown("escape")
	then
		state.game = false
		state.retry = true		
	end
end

function retry()
	love.graphics.setBackgroundColor(40,80,100)


	local title = "RETRY?"
	love.graphics.setFont(fonts[100])
	local spacing = (window_main_w - fonts[100]:getWidth(title))/2
	gui.Label{text = title,
		pos = {spacing, title_top_spacing},
	}
		
	gui.group.push{grow = "right"}
		local btn_back_text = "YES"
		love.graphics.setFont(fonts[40])
		local spacing = (window_main_w - 2 * button_main_menu_w)/2
		if gui.Button{text = btn_back_text,
				pos = {spacing, title_top_spacing * 2},
				size = {button_main_menu_w, button_main_menu_h}}
		then
				state.retry = false
				state.game = true
		end
		
		local btn_back_text = "NO"
		love.graphics.setFont(fonts[40])
		local spacing = (window_main_w - button_main_menu_w)/2
		if gui.Button{text = btn_back_text,
				pos = {gui.group.default_spacing, title_top_spacing * 2},
				size = {button_main_menu_w, button_main_menu_h}}
		then
				state.retry = false
				state.credits = true
		end
    gui.group.pop{}
		
end

function credits()
    
    local title = "CREDITS - press ESC to Quit"
		love.graphics.setFont(fonts[40])
		local spacing = (window_main_w - fonts[40]:getWidth(title))/2
		gui.Label{text = title,
			pos = {spacing, title_top_spacing},
		}
		
	if love.keyboard.isDown("escape")
	then
		state.credits = false
		state.quit = true		
	end
end

function quit()
	love.event.quit()
end
